// Code generated by mockery v2.52.2. DO NOT EDIT.

package gitlab

import (
	mock "github.com/stretchr/testify/mock"
	client_go "gitlab.com/gitlab-org/api/client-go"
)

// MockClient is an autogenerated mock type for the Client type
type MockClient struct {
	mock.Mock
}

type MockClient_Expecter struct {
	mock *mock.Mock
}

func (_m *MockClient) EXPECT() *MockClient_Expecter {
	return &MockClient_Expecter{mock: &_m.Mock}
}

// CreateBranch provides a mock function with given fields: pid, opt, options
func (_m *MockClient) CreateBranch(pid interface{}, opt *client_go.CreateBranchOptions, options ...client_go.RequestOptionFunc) (*client_go.Branch, *client_go.Response, error) {
	_va := make([]interface{}, len(options))
	for _i := range options {
		_va[_i] = options[_i]
	}
	var _ca []interface{}
	_ca = append(_ca, pid, opt)
	_ca = append(_ca, _va...)
	ret := _m.Called(_ca...)

	if len(ret) == 0 {
		panic("no return value specified for CreateBranch")
	}

	var r0 *client_go.Branch
	var r1 *client_go.Response
	var r2 error
	if rf, ok := ret.Get(0).(func(interface{}, *client_go.CreateBranchOptions, ...client_go.RequestOptionFunc) (*client_go.Branch, *client_go.Response, error)); ok {
		return rf(pid, opt, options...)
	}
	if rf, ok := ret.Get(0).(func(interface{}, *client_go.CreateBranchOptions, ...client_go.RequestOptionFunc) *client_go.Branch); ok {
		r0 = rf(pid, opt, options...)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*client_go.Branch)
		}
	}

	if rf, ok := ret.Get(1).(func(interface{}, *client_go.CreateBranchOptions, ...client_go.RequestOptionFunc) *client_go.Response); ok {
		r1 = rf(pid, opt, options...)
	} else {
		if ret.Get(1) != nil {
			r1 = ret.Get(1).(*client_go.Response)
		}
	}

	if rf, ok := ret.Get(2).(func(interface{}, *client_go.CreateBranchOptions, ...client_go.RequestOptionFunc) error); ok {
		r2 = rf(pid, opt, options...)
	} else {
		r2 = ret.Error(2)
	}

	return r0, r1, r2
}

// MockClient_CreateBranch_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'CreateBranch'
type MockClient_CreateBranch_Call struct {
	*mock.Call
}

// CreateBranch is a helper method to define mock.On call
//   - pid interface{}
//   - opt *client_go.CreateBranchOptions
//   - options ...client_go.RequestOptionFunc
func (_e *MockClient_Expecter) CreateBranch(pid interface{}, opt interface{}, options ...interface{}) *MockClient_CreateBranch_Call {
	return &MockClient_CreateBranch_Call{Call: _e.mock.On("CreateBranch",
		append([]interface{}{pid, opt}, options...)...)}
}

func (_c *MockClient_CreateBranch_Call) Run(run func(pid interface{}, opt *client_go.CreateBranchOptions, options ...client_go.RequestOptionFunc)) *MockClient_CreateBranch_Call {
	_c.Call.Run(func(args mock.Arguments) {
		variadicArgs := make([]client_go.RequestOptionFunc, len(args)-2)
		for i, a := range args[2:] {
			if a != nil {
				variadicArgs[i] = a.(client_go.RequestOptionFunc)
			}
		}
		run(args[0].(interface{}), args[1].(*client_go.CreateBranchOptions), variadicArgs...)
	})
	return _c
}

func (_c *MockClient_CreateBranch_Call) Return(_a0 *client_go.Branch, _a1 *client_go.Response, _a2 error) *MockClient_CreateBranch_Call {
	_c.Call.Return(_a0, _a1, _a2)
	return _c
}

func (_c *MockClient_CreateBranch_Call) RunAndReturn(run func(interface{}, *client_go.CreateBranchOptions, ...client_go.RequestOptionFunc) (*client_go.Branch, *client_go.Response, error)) *MockClient_CreateBranch_Call {
	_c.Call.Return(run)
	return _c
}

// CreateCommit provides a mock function with given fields: pid, opt, options
func (_m *MockClient) CreateCommit(pid interface{}, opt *client_go.CreateCommitOptions, options ...client_go.RequestOptionFunc) (*client_go.Commit, *client_go.Response, error) {
	_va := make([]interface{}, len(options))
	for _i := range options {
		_va[_i] = options[_i]
	}
	var _ca []interface{}
	_ca = append(_ca, pid, opt)
	_ca = append(_ca, _va...)
	ret := _m.Called(_ca...)

	if len(ret) == 0 {
		panic("no return value specified for CreateCommit")
	}

	var r0 *client_go.Commit
	var r1 *client_go.Response
	var r2 error
	if rf, ok := ret.Get(0).(func(interface{}, *client_go.CreateCommitOptions, ...client_go.RequestOptionFunc) (*client_go.Commit, *client_go.Response, error)); ok {
		return rf(pid, opt, options...)
	}
	if rf, ok := ret.Get(0).(func(interface{}, *client_go.CreateCommitOptions, ...client_go.RequestOptionFunc) *client_go.Commit); ok {
		r0 = rf(pid, opt, options...)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*client_go.Commit)
		}
	}

	if rf, ok := ret.Get(1).(func(interface{}, *client_go.CreateCommitOptions, ...client_go.RequestOptionFunc) *client_go.Response); ok {
		r1 = rf(pid, opt, options...)
	} else {
		if ret.Get(1) != nil {
			r1 = ret.Get(1).(*client_go.Response)
		}
	}

	if rf, ok := ret.Get(2).(func(interface{}, *client_go.CreateCommitOptions, ...client_go.RequestOptionFunc) error); ok {
		r2 = rf(pid, opt, options...)
	} else {
		r2 = ret.Error(2)
	}

	return r0, r1, r2
}

// MockClient_CreateCommit_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'CreateCommit'
type MockClient_CreateCommit_Call struct {
	*mock.Call
}

// CreateCommit is a helper method to define mock.On call
//   - pid interface{}
//   - opt *client_go.CreateCommitOptions
//   - options ...client_go.RequestOptionFunc
func (_e *MockClient_Expecter) CreateCommit(pid interface{}, opt interface{}, options ...interface{}) *MockClient_CreateCommit_Call {
	return &MockClient_CreateCommit_Call{Call: _e.mock.On("CreateCommit",
		append([]interface{}{pid, opt}, options...)...)}
}

func (_c *MockClient_CreateCommit_Call) Run(run func(pid interface{}, opt *client_go.CreateCommitOptions, options ...client_go.RequestOptionFunc)) *MockClient_CreateCommit_Call {
	_c.Call.Run(func(args mock.Arguments) {
		variadicArgs := make([]client_go.RequestOptionFunc, len(args)-2)
		for i, a := range args[2:] {
			if a != nil {
				variadicArgs[i] = a.(client_go.RequestOptionFunc)
			}
		}
		run(args[0].(interface{}), args[1].(*client_go.CreateCommitOptions), variadicArgs...)
	})
	return _c
}

func (_c *MockClient_CreateCommit_Call) Return(_a0 *client_go.Commit, _a1 *client_go.Response, _a2 error) *MockClient_CreateCommit_Call {
	_c.Call.Return(_a0, _a1, _a2)
	return _c
}

func (_c *MockClient_CreateCommit_Call) RunAndReturn(run func(interface{}, *client_go.CreateCommitOptions, ...client_go.RequestOptionFunc) (*client_go.Commit, *client_go.Response, error)) *MockClient_CreateCommit_Call {
	_c.Call.Return(run)
	return _c
}

// CreateMergeRequest provides a mock function with given fields: pid, opt, options
func (_m *MockClient) CreateMergeRequest(pid interface{}, opt *client_go.CreateMergeRequestOptions, options ...client_go.RequestOptionFunc) (*client_go.MergeRequest, *client_go.Response, error) {
	_va := make([]interface{}, len(options))
	for _i := range options {
		_va[_i] = options[_i]
	}
	var _ca []interface{}
	_ca = append(_ca, pid, opt)
	_ca = append(_ca, _va...)
	ret := _m.Called(_ca...)

	if len(ret) == 0 {
		panic("no return value specified for CreateMergeRequest")
	}

	var r0 *client_go.MergeRequest
	var r1 *client_go.Response
	var r2 error
	if rf, ok := ret.Get(0).(func(interface{}, *client_go.CreateMergeRequestOptions, ...client_go.RequestOptionFunc) (*client_go.MergeRequest, *client_go.Response, error)); ok {
		return rf(pid, opt, options...)
	}
	if rf, ok := ret.Get(0).(func(interface{}, *client_go.CreateMergeRequestOptions, ...client_go.RequestOptionFunc) *client_go.MergeRequest); ok {
		r0 = rf(pid, opt, options...)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*client_go.MergeRequest)
		}
	}

	if rf, ok := ret.Get(1).(func(interface{}, *client_go.CreateMergeRequestOptions, ...client_go.RequestOptionFunc) *client_go.Response); ok {
		r1 = rf(pid, opt, options...)
	} else {
		if ret.Get(1) != nil {
			r1 = ret.Get(1).(*client_go.Response)
		}
	}

	if rf, ok := ret.Get(2).(func(interface{}, *client_go.CreateMergeRequestOptions, ...client_go.RequestOptionFunc) error); ok {
		r2 = rf(pid, opt, options...)
	} else {
		r2 = ret.Error(2)
	}

	return r0, r1, r2
}

// MockClient_CreateMergeRequest_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'CreateMergeRequest'
type MockClient_CreateMergeRequest_Call struct {
	*mock.Call
}

// CreateMergeRequest is a helper method to define mock.On call
//   - pid interface{}
//   - opt *client_go.CreateMergeRequestOptions
//   - options ...client_go.RequestOptionFunc
func (_e *MockClient_Expecter) CreateMergeRequest(pid interface{}, opt interface{}, options ...interface{}) *MockClient_CreateMergeRequest_Call {
	return &MockClient_CreateMergeRequest_Call{Call: _e.mock.On("CreateMergeRequest",
		append([]interface{}{pid, opt}, options...)...)}
}

func (_c *MockClient_CreateMergeRequest_Call) Run(run func(pid interface{}, opt *client_go.CreateMergeRequestOptions, options ...client_go.RequestOptionFunc)) *MockClient_CreateMergeRequest_Call {
	_c.Call.Run(func(args mock.Arguments) {
		variadicArgs := make([]client_go.RequestOptionFunc, len(args)-2)
		for i, a := range args[2:] {
			if a != nil {
				variadicArgs[i] = a.(client_go.RequestOptionFunc)
			}
		}
		run(args[0].(interface{}), args[1].(*client_go.CreateMergeRequestOptions), variadicArgs...)
	})
	return _c
}

func (_c *MockClient_CreateMergeRequest_Call) Return(_a0 *client_go.MergeRequest, _a1 *client_go.Response, _a2 error) *MockClient_CreateMergeRequest_Call {
	_c.Call.Return(_a0, _a1, _a2)
	return _c
}

func (_c *MockClient_CreateMergeRequest_Call) RunAndReturn(run func(interface{}, *client_go.CreateMergeRequestOptions, ...client_go.RequestOptionFunc) (*client_go.MergeRequest, *client_go.Response, error)) *MockClient_CreateMergeRequest_Call {
	_c.Call.Return(run)
	return _c
}

// CreatePipeline provides a mock function with given fields: pid, opt, options
func (_m *MockClient) CreatePipeline(pid interface{}, opt *client_go.CreatePipelineOptions, options ...client_go.RequestOptionFunc) (*client_go.Pipeline, *client_go.Response, error) {
	_va := make([]interface{}, len(options))
	for _i := range options {
		_va[_i] = options[_i]
	}
	var _ca []interface{}
	_ca = append(_ca, pid, opt)
	_ca = append(_ca, _va...)
	ret := _m.Called(_ca...)

	if len(ret) == 0 {
		panic("no return value specified for CreatePipeline")
	}

	var r0 *client_go.Pipeline
	var r1 *client_go.Response
	var r2 error
	if rf, ok := ret.Get(0).(func(interface{}, *client_go.CreatePipelineOptions, ...client_go.RequestOptionFunc) (*client_go.Pipeline, *client_go.Response, error)); ok {
		return rf(pid, opt, options...)
	}
	if rf, ok := ret.Get(0).(func(interface{}, *client_go.CreatePipelineOptions, ...client_go.RequestOptionFunc) *client_go.Pipeline); ok {
		r0 = rf(pid, opt, options...)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*client_go.Pipeline)
		}
	}

	if rf, ok := ret.Get(1).(func(interface{}, *client_go.CreatePipelineOptions, ...client_go.RequestOptionFunc) *client_go.Response); ok {
		r1 = rf(pid, opt, options...)
	} else {
		if ret.Get(1) != nil {
			r1 = ret.Get(1).(*client_go.Response)
		}
	}

	if rf, ok := ret.Get(2).(func(interface{}, *client_go.CreatePipelineOptions, ...client_go.RequestOptionFunc) error); ok {
		r2 = rf(pid, opt, options...)
	} else {
		r2 = ret.Error(2)
	}

	return r0, r1, r2
}

// MockClient_CreatePipeline_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'CreatePipeline'
type MockClient_CreatePipeline_Call struct {
	*mock.Call
}

// CreatePipeline is a helper method to define mock.On call
//   - pid interface{}
//   - opt *client_go.CreatePipelineOptions
//   - options ...client_go.RequestOptionFunc
func (_e *MockClient_Expecter) CreatePipeline(pid interface{}, opt interface{}, options ...interface{}) *MockClient_CreatePipeline_Call {
	return &MockClient_CreatePipeline_Call{Call: _e.mock.On("CreatePipeline",
		append([]interface{}{pid, opt}, options...)...)}
}

func (_c *MockClient_CreatePipeline_Call) Run(run func(pid interface{}, opt *client_go.CreatePipelineOptions, options ...client_go.RequestOptionFunc)) *MockClient_CreatePipeline_Call {
	_c.Call.Run(func(args mock.Arguments) {
		variadicArgs := make([]client_go.RequestOptionFunc, len(args)-2)
		for i, a := range args[2:] {
			if a != nil {
				variadicArgs[i] = a.(client_go.RequestOptionFunc)
			}
		}
		run(args[0].(interface{}), args[1].(*client_go.CreatePipelineOptions), variadicArgs...)
	})
	return _c
}

func (_c *MockClient_CreatePipeline_Call) Return(_a0 *client_go.Pipeline, _a1 *client_go.Response, _a2 error) *MockClient_CreatePipeline_Call {
	_c.Call.Return(_a0, _a1, _a2)
	return _c
}

func (_c *MockClient_CreatePipeline_Call) RunAndReturn(run func(interface{}, *client_go.CreatePipelineOptions, ...client_go.RequestOptionFunc) (*client_go.Pipeline, *client_go.Response, error)) *MockClient_CreatePipeline_Call {
	_c.Call.Return(run)
	return _c
}

// GetBranch provides a mock function with given fields: pid, branch, options
func (_m *MockClient) GetBranch(pid interface{}, branch string, options ...client_go.RequestOptionFunc) (*client_go.Branch, *client_go.Response, error) {
	_va := make([]interface{}, len(options))
	for _i := range options {
		_va[_i] = options[_i]
	}
	var _ca []interface{}
	_ca = append(_ca, pid, branch)
	_ca = append(_ca, _va...)
	ret := _m.Called(_ca...)

	if len(ret) == 0 {
		panic("no return value specified for GetBranch")
	}

	var r0 *client_go.Branch
	var r1 *client_go.Response
	var r2 error
	if rf, ok := ret.Get(0).(func(interface{}, string, ...client_go.RequestOptionFunc) (*client_go.Branch, *client_go.Response, error)); ok {
		return rf(pid, branch, options...)
	}
	if rf, ok := ret.Get(0).(func(interface{}, string, ...client_go.RequestOptionFunc) *client_go.Branch); ok {
		r0 = rf(pid, branch, options...)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*client_go.Branch)
		}
	}

	if rf, ok := ret.Get(1).(func(interface{}, string, ...client_go.RequestOptionFunc) *client_go.Response); ok {
		r1 = rf(pid, branch, options...)
	} else {
		if ret.Get(1) != nil {
			r1 = ret.Get(1).(*client_go.Response)
		}
	}

	if rf, ok := ret.Get(2).(func(interface{}, string, ...client_go.RequestOptionFunc) error); ok {
		r2 = rf(pid, branch, options...)
	} else {
		r2 = ret.Error(2)
	}

	return r0, r1, r2
}

// MockClient_GetBranch_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'GetBranch'
type MockClient_GetBranch_Call struct {
	*mock.Call
}

// GetBranch is a helper method to define mock.On call
//   - pid interface{}
//   - branch string
//   - options ...client_go.RequestOptionFunc
func (_e *MockClient_Expecter) GetBranch(pid interface{}, branch interface{}, options ...interface{}) *MockClient_GetBranch_Call {
	return &MockClient_GetBranch_Call{Call: _e.mock.On("GetBranch",
		append([]interface{}{pid, branch}, options...)...)}
}

func (_c *MockClient_GetBranch_Call) Run(run func(pid interface{}, branch string, options ...client_go.RequestOptionFunc)) *MockClient_GetBranch_Call {
	_c.Call.Run(func(args mock.Arguments) {
		variadicArgs := make([]client_go.RequestOptionFunc, len(args)-2)
		for i, a := range args[2:] {
			if a != nil {
				variadicArgs[i] = a.(client_go.RequestOptionFunc)
			}
		}
		run(args[0].(interface{}), args[1].(string), variadicArgs...)
	})
	return _c
}

func (_c *MockClient_GetBranch_Call) Return(_a0 *client_go.Branch, _a1 *client_go.Response, _a2 error) *MockClient_GetBranch_Call {
	_c.Call.Return(_a0, _a1, _a2)
	return _c
}

func (_c *MockClient_GetBranch_Call) RunAndReturn(run func(interface{}, string, ...client_go.RequestOptionFunc) (*client_go.Branch, *client_go.Response, error)) *MockClient_GetBranch_Call {
	_c.Call.Return(run)
	return _c
}

// GetPipeline provides a mock function with given fields: pid, pipelineID, options
func (_m *MockClient) GetPipeline(pid interface{}, pipelineID int, options ...client_go.RequestOptionFunc) (*client_go.Pipeline, *client_go.Response, error) {
	_va := make([]interface{}, len(options))
	for _i := range options {
		_va[_i] = options[_i]
	}
	var _ca []interface{}
	_ca = append(_ca, pid, pipelineID)
	_ca = append(_ca, _va...)
	ret := _m.Called(_ca...)

	if len(ret) == 0 {
		panic("no return value specified for GetPipeline")
	}

	var r0 *client_go.Pipeline
	var r1 *client_go.Response
	var r2 error
	if rf, ok := ret.Get(0).(func(interface{}, int, ...client_go.RequestOptionFunc) (*client_go.Pipeline, *client_go.Response, error)); ok {
		return rf(pid, pipelineID, options...)
	}
	if rf, ok := ret.Get(0).(func(interface{}, int, ...client_go.RequestOptionFunc) *client_go.Pipeline); ok {
		r0 = rf(pid, pipelineID, options...)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*client_go.Pipeline)
		}
	}

	if rf, ok := ret.Get(1).(func(interface{}, int, ...client_go.RequestOptionFunc) *client_go.Response); ok {
		r1 = rf(pid, pipelineID, options...)
	} else {
		if ret.Get(1) != nil {
			r1 = ret.Get(1).(*client_go.Response)
		}
	}

	if rf, ok := ret.Get(2).(func(interface{}, int, ...client_go.RequestOptionFunc) error); ok {
		r2 = rf(pid, pipelineID, options...)
	} else {
		r2 = ret.Error(2)
	}

	return r0, r1, r2
}

// MockClient_GetPipeline_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'GetPipeline'
type MockClient_GetPipeline_Call struct {
	*mock.Call
}

// GetPipeline is a helper method to define mock.On call
//   - pid interface{}
//   - pipelineID int
//   - options ...client_go.RequestOptionFunc
func (_e *MockClient_Expecter) GetPipeline(pid interface{}, pipelineID interface{}, options ...interface{}) *MockClient_GetPipeline_Call {
	return &MockClient_GetPipeline_Call{Call: _e.mock.On("GetPipeline",
		append([]interface{}{pid, pipelineID}, options...)...)}
}

func (_c *MockClient_GetPipeline_Call) Run(run func(pid interface{}, pipelineID int, options ...client_go.RequestOptionFunc)) *MockClient_GetPipeline_Call {
	_c.Call.Run(func(args mock.Arguments) {
		variadicArgs := make([]client_go.RequestOptionFunc, len(args)-2)
		for i, a := range args[2:] {
			if a != nil {
				variadicArgs[i] = a.(client_go.RequestOptionFunc)
			}
		}
		run(args[0].(interface{}), args[1].(int), variadicArgs...)
	})
	return _c
}

func (_c *MockClient_GetPipeline_Call) Return(_a0 *client_go.Pipeline, _a1 *client_go.Response, _a2 error) *MockClient_GetPipeline_Call {
	_c.Call.Return(_a0, _a1, _a2)
	return _c
}

func (_c *MockClient_GetPipeline_Call) RunAndReturn(run func(interface{}, int, ...client_go.RequestOptionFunc) (*client_go.Pipeline, *client_go.Response, error)) *MockClient_GetPipeline_Call {
	_c.Call.Return(run)
	return _c
}

// GetRawFile provides a mock function with given fields: pid, filepath, opt, options
func (_m *MockClient) GetRawFile(pid interface{}, filepath string, opt *client_go.GetRawFileOptions, options ...client_go.RequestOptionFunc) ([]byte, *client_go.Response, error) {
	_va := make([]interface{}, len(options))
	for _i := range options {
		_va[_i] = options[_i]
	}
	var _ca []interface{}
	_ca = append(_ca, pid, filepath, opt)
	_ca = append(_ca, _va...)
	ret := _m.Called(_ca...)

	if len(ret) == 0 {
		panic("no return value specified for GetRawFile")
	}

	var r0 []byte
	var r1 *client_go.Response
	var r2 error
	if rf, ok := ret.Get(0).(func(interface{}, string, *client_go.GetRawFileOptions, ...client_go.RequestOptionFunc) ([]byte, *client_go.Response, error)); ok {
		return rf(pid, filepath, opt, options...)
	}
	if rf, ok := ret.Get(0).(func(interface{}, string, *client_go.GetRawFileOptions, ...client_go.RequestOptionFunc) []byte); ok {
		r0 = rf(pid, filepath, opt, options...)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).([]byte)
		}
	}

	if rf, ok := ret.Get(1).(func(interface{}, string, *client_go.GetRawFileOptions, ...client_go.RequestOptionFunc) *client_go.Response); ok {
		r1 = rf(pid, filepath, opt, options...)
	} else {
		if ret.Get(1) != nil {
			r1 = ret.Get(1).(*client_go.Response)
		}
	}

	if rf, ok := ret.Get(2).(func(interface{}, string, *client_go.GetRawFileOptions, ...client_go.RequestOptionFunc) error); ok {
		r2 = rf(pid, filepath, opt, options...)
	} else {
		r2 = ret.Error(2)
	}

	return r0, r1, r2
}

// MockClient_GetRawFile_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'GetRawFile'
type MockClient_GetRawFile_Call struct {
	*mock.Call
}

// GetRawFile is a helper method to define mock.On call
//   - pid interface{}
//   - filepath string
//   - opt *client_go.GetRawFileOptions
//   - options ...client_go.RequestOptionFunc
func (_e *MockClient_Expecter) GetRawFile(pid interface{}, filepath interface{}, opt interface{}, options ...interface{}) *MockClient_GetRawFile_Call {
	return &MockClient_GetRawFile_Call{Call: _e.mock.On("GetRawFile",
		append([]interface{}{pid, filepath, opt}, options...)...)}
}

func (_c *MockClient_GetRawFile_Call) Run(run func(pid interface{}, filepath string, opt *client_go.GetRawFileOptions, options ...client_go.RequestOptionFunc)) *MockClient_GetRawFile_Call {
	_c.Call.Run(func(args mock.Arguments) {
		variadicArgs := make([]client_go.RequestOptionFunc, len(args)-3)
		for i, a := range args[3:] {
			if a != nil {
				variadicArgs[i] = a.(client_go.RequestOptionFunc)
			}
		}
		run(args[0].(interface{}), args[1].(string), args[2].(*client_go.GetRawFileOptions), variadicArgs...)
	})
	return _c
}

func (_c *MockClient_GetRawFile_Call) Return(_a0 []byte, _a1 *client_go.Response, _a2 error) *MockClient_GetRawFile_Call {
	_c.Call.Return(_a0, _a1, _a2)
	return _c
}

func (_c *MockClient_GetRawFile_Call) RunAndReturn(run func(interface{}, string, *client_go.GetRawFileOptions, ...client_go.RequestOptionFunc) ([]byte, *client_go.Response, error)) *MockClient_GetRawFile_Call {
	_c.Call.Return(run)
	return _c
}

// ListTree provides a mock function with given fields: pid, opt, options
func (_m *MockClient) ListTree(pid interface{}, opt *client_go.ListTreeOptions, options ...client_go.RequestOptionFunc) ([]*client_go.TreeNode, *client_go.Response, error) {
	_va := make([]interface{}, len(options))
	for _i := range options {
		_va[_i] = options[_i]
	}
	var _ca []interface{}
	_ca = append(_ca, pid, opt)
	_ca = append(_ca, _va...)
	ret := _m.Called(_ca...)

	if len(ret) == 0 {
		panic("no return value specified for ListTree")
	}

	var r0 []*client_go.TreeNode
	var r1 *client_go.Response
	var r2 error
	if rf, ok := ret.Get(0).(func(interface{}, *client_go.ListTreeOptions, ...client_go.RequestOptionFunc) ([]*client_go.TreeNode, *client_go.Response, error)); ok {
		return rf(pid, opt, options...)
	}
	if rf, ok := ret.Get(0).(func(interface{}, *client_go.ListTreeOptions, ...client_go.RequestOptionFunc) []*client_go.TreeNode); ok {
		r0 = rf(pid, opt, options...)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).([]*client_go.TreeNode)
		}
	}

	if rf, ok := ret.Get(1).(func(interface{}, *client_go.ListTreeOptions, ...client_go.RequestOptionFunc) *client_go.Response); ok {
		r1 = rf(pid, opt, options...)
	} else {
		if ret.Get(1) != nil {
			r1 = ret.Get(1).(*client_go.Response)
		}
	}

	if rf, ok := ret.Get(2).(func(interface{}, *client_go.ListTreeOptions, ...client_go.RequestOptionFunc) error); ok {
		r2 = rf(pid, opt, options...)
	} else {
		r2 = ret.Error(2)
	}

	return r0, r1, r2
}

// MockClient_ListTree_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'ListTree'
type MockClient_ListTree_Call struct {
	*mock.Call
}

// ListTree is a helper method to define mock.On call
//   - pid interface{}
//   - opt *client_go.ListTreeOptions
//   - options ...client_go.RequestOptionFunc
func (_e *MockClient_Expecter) ListTree(pid interface{}, opt interface{}, options ...interface{}) *MockClient_ListTree_Call {
	return &MockClient_ListTree_Call{Call: _e.mock.On("ListTree",
		append([]interface{}{pid, opt}, options...)...)}
}

func (_c *MockClient_ListTree_Call) Run(run func(pid interface{}, opt *client_go.ListTreeOptions, options ...client_go.RequestOptionFunc)) *MockClient_ListTree_Call {
	_c.Call.Run(func(args mock.Arguments) {
		variadicArgs := make([]client_go.RequestOptionFunc, len(args)-2)
		for i, a := range args[2:] {
			if a != nil {
				variadicArgs[i] = a.(client_go.RequestOptionFunc)
			}
		}
		run(args[0].(interface{}), args[1].(*client_go.ListTreeOptions), variadicArgs...)
	})
	return _c
}

func (_c *MockClient_ListTree_Call) Return(_a0 []*client_go.TreeNode, _a1 *client_go.Response, _a2 error) *MockClient_ListTree_Call {
	_c.Call.Return(_a0, _a1, _a2)
	return _c
}

func (_c *MockClient_ListTree_Call) RunAndReturn(run func(interface{}, *client_go.ListTreeOptions, ...client_go.RequestOptionFunc) ([]*client_go.TreeNode, *client_go.Response, error)) *MockClient_ListTree_Call {
	_c.Call.Return(run)
	return _c
}

// NewMockClient creates a new instance of MockClient. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
// The first argument is typically a *testing.T value.
func NewMockClient(t interface {
	mock.TestingT
	Cleanup(func())
}) *MockClient {
	mock := &MockClient{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
